var draw;

var doUpdateNews;
var doUpdateBoard;
var doUpdateScores;

function message(str)
{
	//alert(str);
	$("#message").html(str);
	$("#message").slideDown();
	setTimeout("destroyMessage()", 5000);
}

function destroyMessage() {
	$("#message").slideUp();
}

function loginButton()
{
	passHash=hex_sha256($('#login-password').val());
	login($('#login-user').val(),passHash);
	return false;
}

function logoutButton()
{
	localStorage.removeItem('user');
	localStorage.removeItem('passHash');
	gteamID = 0;
	gpassHash = "thisishowwegetants";
	$('#box-login').slideUp();
	message('You have been logged out.');
	$('#login-password').val("");
	$('#login-user').val("");
	$('#login-submit').val("login");
	//$('#login-submit').unbind('click').click(loginButton);
	$('#login-submit').unbind('click');
	return false;
}

function login(user, hash)
{
	$.getJSON("/ajax/validateCreds", { method: "validateCreds", teamID: user, passHash: hash }, function(data) {
			message(data.msg);

			if (data['return'] == true)
			{
			//check for localstorage support
			localStorage.setItem('user',user);
			localStorage.setItem('passHash',hash);
			drawLogin(user);
			
			gteamID = user;
			gpassHash = hash;

			$('#box-login').slideUp();
			}
		});
}

function drawLogin(user)
{
	$('#username').val(user);
	$('#password').val('boguspw');
	$('#login-submit').val('logout');
	$('#login-submit').unbind('click').click(function() { logoutButton(); });
}


function Update() {
	if (doUpdateNews) {
		getNews();
	}
	if (doUpdateScores) {
		getScores();
	}
	if (doUpdateBoard) {
		getBoard();
	}
}

function getNews() {
	$.getJSON("/ajax/getNews", { method: "getNews" }, function(data) {
			if (data['return'] == true) {
				var news = data.news;
	
				$("#news-items").html("");
	
				$.each(news, function(i, line) {
					$("#news-items").append("<h3>" + line.timestamp + "</h3><p>" + line.item + "</p>");	
				});
			}
	});
}

function getScores() {
	var lteamID;
	if (typeof(gteamID) == "undefined") {
		lteamID = 0;
	} else {
		lteamID = gteamID;
	}

	$.getJSON("/ajax/getScores", { method: "getScores", teamID: lteamID }, function(data) {
		if (data['return'] == true) {
			var scores = data.entry;
			$("#scoreboard-body").html("");
			if (typeof(gteamID) != "undefined") {
				var myteam = data.myteam;

				$("#scoreboard-body").html("<tr id='myteam'><th>"+myteam.team+"</th><th>"+myteam.score+"</th></tr>");
			}
			var toggle = 1;
			$.each(scores, function(i, line) {
				if (toggle) {
				$("#scoreboard-body").append("<tr><td>"+(i+1)+". "+line.team+"</td><td>"+line.score+"</td></tr>");
				} else {
				$("#scoreboard-body").append("<tr id='odd'><td>"+(i+1)+". "+line.team+"</td><td>"+line.score+"</td></tr>");
				}
				toggle ^= 1;
				});
			}

			});
}

function getBoard() {
	var lteamID;
	var lpassHash;
	if (typeof(gteamID) == "undefined") {
		lteamID = 0;
		lpassHash = "thisishowwegetants";
	} else {
		lteamID = gteamID;
		lpassHash = gpassHash;
	}
	$.getJSON("/ajax/getBoard", { method: "getBoard", teamID: lteamID, passHash: lpassHash}, function(data) {
			if (data) {
			board = data.board;

			for (var i = 0; i < 29; i++) {
				$("#id"+i).attr("src","images/"+i+".png");
			}

			$.each(board, function(i, item) {
				var color = "";

				if (item.status == "unlocked") {
					color = "_b";
		
					$("#id"+item.stageid).unbind();
					$("#id"+item.stageid).click(function() { displayQuestion(item.stageid); });
					$("#id"+item.stageid).hover(function() { hoverItem(item.stageid, color); });

				} else if (item.status == "available") {
					color = "_y";
	
					$("#id"+item.stageid).unbind();
					$("#id"+item.stageid).click(function() { chooseYourDestiny(item.stageid); });
					$("#id"+item.stageid).hover(function() { hoverItem(item.stageid, color); });
	
				} else if (item.status == "solved") {
					color = "_g";
	
					$("#id"+item.stageid).unbind();
					$("#id"+item.stageid).click(function() { displayQuestion(item.stageid); });
					$("#id"+item.stageid).hover(function() { hoverItem(item.stageid, color); });
				} else if (item.status == "disabled") {
					color = "_r";

					$("#id"+item.stageid).unbind();
					$("#id"+item.stageid).click(function () { message("Oh crap! Someone just ran by with a sign with the answer!"); });
					$("#id"+item.stageid).hover(function() { hoverItem(item.stageid, color); });
				} else if (item.status == "unsolved") {
					color = "_p";

					$("#id"+item.stageid).unbind();
					$("#id"+item.stageid).click(function() { displayQuestion(item.stageid); });
					$("#id"+item.stageid).hover(function() { hoverItem(item.stageid, color); });
				}

				$("#id"+item.stageid).attr("src","images/"+item.stageid+color+".png");
			});
			}
	});
}

function hoverItem(stageid, color) {
	$.each(board, function(i, item) {
		if (item.stageid == stageid) {
			if ($("#id"+item.stageid).attr("alt") != "Selected") {
				$("#id"+item.stageid).attr("src","images/"+item.stageid+color+"s.png");
				$("#id"+item.stageid).attr("alt","Selected");
			} else {
				$("#id"+item.stageid).attr("src","images/"+item.stageid+color+".png");
				$("#id"+item.stageid).attr("alt","Unselected");
			}
		}
	});
}

function submitAnswer() {
	if (typeof(gteamID) == "undefined") {
		message("You must log in before you can submit an answer");
	} else {
		$.getJSON("/ajax/answer", { method: "answer", teamID: gteamID, passHash: gpassHash, stage: open, answer: $("#q-input").attr("value") }, function(data) {
			if (data['return'] == true) {
				// Correct!
				message("Correct!");
				$("#box-question").slideUp();
			} else {
				message("Incorrect. :(");
			}
		});
	}
	return false;
}

function displayQuestion(stageid) {
	$("#box-question").slideUp();

	$.each(board, function(i, item) {
		if (item.stageid == stageid) {
			$("#q-stage").html("Stage "+item.stage);
			$("#q-name").html("Question: "+item.name);
			$("#q-points").html(item.points+" Points");
			$("#q-prompt").html(item.question);

			if (item.status == "solved") {
				$("#q-input").slideUp();
				$("#q-submit").slideUp();
			} else {
				$("#q-input").slideDown();
				$("#q-submit").slideDown();
			}
		}
	});

	open = stageid;
	
	if (draw != stageid) {
		$("#box-question").slideDown("slow");
		draw = 0;
	} else {
		draw = stageid;
	}

}

function chooseYourDestiny(stageid) {
	if (typeof(gteamID) == "undefined") {
		message("You must log in before you can submit an answer");
	} else {
		$.getJSON("/ajax/openStage", { method: "openStage", teamID: gteamID, passHash: gpassHash, stage: stageid }, function(data) {
				message(data.msg);
				/* if (data['return'] == true) {
					$("#box-question").slideDown();
					getBoard();
				}
				*/
		});
	}
}


$(document).ready(function()
{
	if ((localStorage.getItem('user') !== null) && (localStorage.getItem('passHash') !== null))
	{
		login(localStorage.getItem('user'),localStorage.getItem('passHash'));
	}
	
	//$('#login-submit').click(function() { loginButton(); return false; });
	//here
	$('#lform').submit(function() { loginButton(); return false; });

});

